package xyz.devcomp.touch_grass_reminder.config;

import net.minecraft.client.gui.screens.Screen;
import net.minecraft.resources.ResourceLocation;
import xyz.devcomp.touch_grass_reminder.client.TouchGrassReminderClient;

import org.quiltmc.loader.api.QuiltLoader;

import dev.isxander.yacl3.config.v2.api.ConfigClassHandler;
import dev.isxander.yacl3.config.v2.api.serializer.GsonConfigSerializerBuilder;

public class ConfigHandler {
    private boolean isLoaded = false;
    public static final ConfigClassHandler<ConfigModel> HANDLER = ConfigClassHandler.createBuilder(ConfigModel.class)
            .id(new ResourceLocation("touchgrassreminder", "config"))
            .serializer(config -> GsonConfigSerializerBuilder.create(config)
                    .setPath(QuiltLoader.getConfigDir().resolve("touch-grass-reminder.json"))
                    .setJson5(true)
                    .build())
            .build();

    private void loadConfig() {
        if (!this.isLoaded) {
            this.isLoaded = HANDLER.load();
            TouchGrassReminderClient.LOGGER.info("Config not loaded. Attempting to load.");
        }
    }

    public Screen showGui(Screen parent) {
        this.loadConfig();
        return HANDLER.generateGui().generateScreen(parent);
    }

    public ConfigModel getInstance() {
        this.loadConfig();
        return HANDLER.instance();
    }
}
